%define bootstrap	0
%{?_without_bootstrap:	%global bootstrap 0}
%{?_with_bootstrap:	%global bootstrap 1}

# disable by default, mozjs185 symbols conflict with firefox and make it crash (#6299)
# see also https://bugzilla.novell.com/show_bug.cgi?id=759123
#          https://bugzilla.mozilla.org/show_bug.cgi?id=763185
%bcond_with mozjs

%define major		1
%define libname		%mklibname proxy %{major}
%define develname	%mklibname -d proxy
%define gnomename	%mklibname proxy-gnome
%define kdename		%mklibname proxy-kde
%define nmname		%mklibname proxy-networkmanager
%define mozjsname	%mklibname proxy-mozjs
%define webkitname	%mklibname proxy-webkit
%define first_biarch_version	0.4.7-2
%define _libexecdir	%{_prefix}/lib

Name:           libproxy
Version:        0.4.15
%define subrel 2
Release:        %mkrel 4
Summary:        A library handling all the details of proxy configuration

Group:          System/Libraries
License:        LGPLv2+
URL:            https://libproxy.github.io/libproxy/
Source0:        https://github.com/libproxy/%{name}/releases/download/%{version}/%{name}-%{version}.tar.xz
# Taken from the Debian package.
Source1:        proxy.1
# http://code.google.com/p/libproxy/issues/detail?id=152
Patch0:         0001-Add-config-module-for-querying-PacRunner-d-mon.patch
Patch1:         CVE-2020-25219.patch
Patch2:         libproxy-0.4.15-fix-pac-buffer-overflow.patch

BuildRequires:  cmake
BuildRequires:  pkgconfig(python2)
BuildRequires:  pkgconfig(python3)
#perl
BuildRequires:  perl-devel
%if !%{bootstrap}
%if %{with mozjs}
# mozjs
BuildRequires:  pkgconfig(mozjs185)
%endif
# NetworkManager
BuildRequires:  pkgconfig(NetworkManager)
BuildRequires:  pkgconfig(dbus-glib-1)
# gnome3
BuildRequires:	glib2-devel >= 2.26
# webkit (gtk)
BuildRequires:  pkgconfig(javascriptcoregtk-4.0)

BuildRequires:  pkgconfig(xmu)
%endif


%description
libproxy offers the following features:

    * extremely small core footprint (< 35K)
    * no external dependencies within libproxy core
      (libproxy plugins may have dependencies)
    * only 3 functions in the stable external API
    * dynamic adjustment to changing network topology
    * a standard way of dealing with proxy settings across all scenarios
    * a sublime sense of joy and accomplishment 

%package -n     %{libname}
Group:          System/Libraries
Summary:        A library handling all the details of proxy configuration
#Virtual Provides - We need either mozjs or WebKit
%if !%{bootstrap}
Requires:       %{name}-pac >= %{version}
%endif
Obsoletes:	libproxy0
%if !%{with mozjs}
Obsoletes:      %{mklibname proxy-mozjs} < %{version}-%{release}
%endif

%description -n %{libname}
libproxy offers the following features:

    * extremely small core footprint (< 35K)
    * no external dependencies within libproxy core
      (libproxy plugins may have dependencies)
    * only 3 functions in the stable external API
    * dynamic adjustment to changing network topology
    * a standard way of dealing with proxy settings across all scenarios
    * a sublime sense of joy and accomplishment 

%package        utils
Summary:        Binary to test %{name}
Group:          System/Networking
Requires:       %{libname} = %{version}-%{release}

%description    utils
The %{name}-utils package contains the proxy binary for %{name}

%package -n python2-%{name}
Summary:        Binding for %{name} and python2
Group:          Development/Python
Requires:       %{libname} = %{version}-%{release}

Obsoletes:      python-%{name} < 0.4.15-4
Provides:       python-%{name} = %{version}-%{release}

%description -n python2-%{name}
The python2-%{name} package contains the python2 binding for %{name}

%package -n python3-%{name}
Summary:        Binding for %{name} and python3
Group:          Development/Python
Requires:       %{libname} = %{version}-%{release}

%description -n python3-%{name}
The python3-%{name} package contains the python3 binding for %{name}

%package        perl
Summary:        Perl bindings for %{name}
Group:          Development/Perl
Requires:       %{libname} = %{version}-%{release}

%description    perl
This contains the perl bindings for the libproxy library.

%package	gxsettings
Summary:	Helper utility for %{name} gnome support
Group:		System/Libraries

%description gxsettings
A helper utility for %{name} gnome support.

%package -n     %{gnomename}
Summary:        Plugin for %{name} and gnome
Group:          System/Libraries
Requires:       %{libname} = %{version}-%{release}
%if !%{bootstrap}
Requires:       %{nmname} = %{version}-%{release}
%endif
Requires:	%{name}-gxsettings = %{version}-%{release}
Obsoletes:	libproxy-gnome < %{first_biarch_version}
Requires:	gsettings-desktop-schemas

%description -n %{gnomename}
The %{name}-gnome package contains the %{name} plugin for gnome.

%package -n     %{kdename}
Summary:        Plugin for %{name} and kde
Group:          System/Libraries
Requires:       %{libname} = %{version}-%{release}
Requires:       %{nmname} = %{version}-%{release}
# for kreadconfig5
Requires:	kconfig
Obsoletes:	libproxy-kde < %{first_biarch_version}

%description -n %{kdename}
The %{name}-kde package contains the %{name} plugin for kde.

%if !%{bootstrap}
%package -n     %{nmname}
Summary:        Plugin for %{name} and NetworkManager
Group:          System/Libraries
Requires:       %{libname} = %{version}-%{release}

%description -n %{nmname}
The %{name}-networkmanager package contains the %{name} plugin for NetworkManager.

%package -n     %{mozjsname}
Summary:        Plugin for %{name} and mozjs
Group:          System/Libraries
Requires:       %{libname} = %{version}
Provides:       %{name}-pac = %{version}-%{release}
Obsoletes:	libproxy-mozjs < %{first_biarch_version}

%description -n %{mozjsname}
The %{name}-mozjs package contains the %{name} plugin for mozjs.

%package -n     %{webkitname}
Summary:        Plugin for %{name} and webkit
Group:          System/Libraries
Requires:       %{libname} = %{version}
Provides:       %{name}-pac = %{version}-%{release}
Obsoletes:	libgnome-webkit < %{first_biarch_version}

%description -n %{webkitname}
The %{name}-webkit package contains the %{name} plugin for
webkit.
%endif

%package        pacrunner
Summary:        Plugin for %{name} and PacRunner
Group:          System/Libraries
Requires:       %{libname} = %{version}
Provides:       %{name}-pac = %{version}-%{release}
#Requires:       pacrunner

%description    pacrunner
The %{name}-pacrunner package contains the %{name} plugin for
PacRunner.

%package -n %{develname}
Summary:        Development files for %{name}
Group:          Development/C
Requires:       %{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n %{develname}
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%setup -q
%autopatch -p1

%build
%if %{bootstrap}
export CC="gcc -L$(pkg-config --variable sdkdir libxul)/lib"
%endif
# (blino) do not build pacrunner as internal (BIPR=OFF), to avoid having gtk deps in the main package
%cmake \
	-DLIBEXEC_INSTALL_DIR=%{_libexecdir} \
	-DMODULE_INSTALL_DIR=%{_libdir}/%{name}/%{version}/modules \
	-DBIPR=OFF \
%if !%{with mozjs}
	-DWITH_MOZJS=OFF \
%endif
	-DPERL_VENDORINSTALL=1 \
	-DPERL_LINK_LIBPERL=1 \
	-DWITH_WEBKIT3=1 \
	-DPYTHON3_EXECUTABLE=%{__python3} \
	-DPYTHON3_SITEPKG_DIR=%{python3_sitelib}
%make_build

%install
%make_install -C build

# Man page.
install -Dpm 0644 %{SOURCE1} %{buildroot}/%{_mandir}/man1/proxy.1

#gw fix pkgconfig file
sed -i -e "s^Version:.*^Version: %version^" %{buildroot}%{_libdir}/pkgconfig/*.pc

%files -n %{libname}
%doc AUTHORS README
%{_libdir}/libproxy.so.%{major}{,.*}
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/%{version}
%dir %{_libdir}/%{name}/%{version}/modules

%files utils
%{_bindir}/proxy
%{_mandir}/man1/proxy.1*

%files -n python2-%{name}
%{python2_sitelib}/*

%files -n python3-%{name}
%{python3_sitelib}/*

%files perl
%{perl_vendorarch}/Net/Libproxy.pm
%{perl_vendorarch}/auto/Net/Libproxy

%files gxsettings
%{_libexecdir}/pxgsettings
#{_prefix}/libexec/pxgsettings

%files -n %{gnomename}
%{_libdir}/%{name}/%{version}/modules/config_gnome3.so

%files -n %{kdename}
%{_libdir}/%{name}/%{version}/modules/config_kde.so

%if !%{bootstrap}
%files -n %{nmname}
%{_libdir}/%{name}/%{version}/modules/network_networkmanager.so

%if %{with mozjs}
%files -n %{mozjsname}
%{_libdir}/%{name}/%{version}/modules/pacrunner_mozjs.so
%endif

%files -n %{webkitname}
%{_libdir}/%{name}/%{version}/modules/pacrunner_webkit.so

%files pacrunner
%{_libdir}/%{name}/%{version}/modules/config_pacrunner.so
%endif

%files -n %{develname}
%{_includedir}/proxy.h
%{_libdir}/*.so
%{_libdir}/pkgconfig/libproxy-1.0.pc
%{_datadir}/cmake/Modules/Findlibproxy.cmake


%changelog
* Thu Oct 15 2020 ns80 <ns80> 0.4.15-4.2.mga7
+ Revision: 1636232
- add Fedora patch for CVE-2020-26154 (mga#27411)
- add Ubuntu patch for CVE-2020-25219 (mga#27302)

* Wed Jan 09 2019 daviddavid <daviddavid> 0.4.15-4.mga7
+ Revision: 1353089
- rebuild for new Python 3.7
- rename python-libproxy to python2-libproxy

* Sun Sep 23 2018 umeabot <umeabot> 0.4.15-3.mga7
+ Revision: 1299101
- Mageia 7 Mass Rebuild

* Tue Aug 07 2018 pterjan <pterjan> 0.4.15-2.mga7
+ Revision: 1248926
- Rebuild for perl 5.28

* Mon Apr 16 2018 kekepower <kekepower> 0.4.15-1.mga7
+ Revision: 1219477
- Update to verion 0.4.15

* Sat Aug 05 2017 pterjan <pterjan> 0.4.14-3.mga7
+ Revision: 1135257
- Rebuild for python 3.6

* Sat Jul 22 2017 neoclust <neoclust> 0.4.14-2.mga7
+ Revision: 1126742
- Rebuild against new Perl 5.26

* Wed Jan 11 2017 luigiwalser <luigiwalser> 0.4.14-1.mga6
+ Revision: 1081067
- 0.4.14
- add python3 subpackage

* Sat May 14 2016 tv <tv> 0.4.13-2.mga6
+ Revision: 1015200
- package config_pacrunner
- patch 0: add config module for querying PacRunner dæmon
- add man page
- use std build macro

* Mon May 09 2016 luigiwalser <luigiwalser> 0.4.13-1.mga6
+ Revision: 1011622
- remove upstream patches
- 0.4.13

* Mon Jan 25 2016 luigiwalser <luigiwalser> 0.4.12-1.mga6
+ Revision: 927495
- add upstream patch to fix linking with libperl
- 0.4.12
- update URLs
- add upstream patches to fix KF5 build for kde module
- add upstream patch to build against webkit2

* Mon Oct 19 2015 daviddavid <daviddavid> 0.4.11-13.mga6
+ Revision: 892834
- fix python macros (fix build failure)

* Thu Jun 25 2015 tv <tv> 0.4.11-12.mga6
+ Revision: 843441
- rebuild with soname-ified perl

* Tue Jun 23 2015 sander85 <sander85> 0.4.11-11.mga6
+ Revision: 840665
- Rebuild for perl 5.22

* Wed Oct 15 2014 umeabot <umeabot> 0.4.11-10.mga5
+ Revision: 739584
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 0.4.11-9.mga5
+ Revision: 726842
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 0.4.11-8.mga5
+ Revision: 681722
- Mageia 5 Mass Rebuild

* Tue Jun 03 2014 pterjan <pterjan> 0.4.11-7.mga5
+ Revision: 630730
- Rebuild for perl 5.20

* Sat May 31 2014 pterjan <pterjan> 0.4.11-6.mga5
+ Revision: 628306
- Rebuild for new Python

* Sat Oct 19 2013 umeabot <umeabot> 0.4.11-5.mga4
+ Revision: 524153
- Mageia 4 Mass Rebuild

* Wed May 29 2013 fwang <fwang> 0.4.11-4.mga4
+ Revision: 430416
- rebuild for new perl

* Tue Jan 22 2013 fwang <fwang> 0.4.11-3.mga3
+ Revision: 390902
- update rpm group

* Sat Jan 12 2013 umeabot <umeabot> 0.4.11-2.mga3
+ Revision: 358008
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Dec 25 2012 luigiwalser <luigiwalser> 0.4.11-1.mga3
+ Revision: 334840
- 0.4.11

* Fri Oct 19 2012 blino <blino> 0.4.10-1.mga3
+ Revision: 308355
- drop custom patch and use new BIPR option to disable building pac runner as internal
- 0.4.10
- drop merged patches

* Thu Oct 11 2012 ovitters <ovitters> 0.4.7-10.mga3
+ Revision: 304660
- add require on gsettings-desktop-schemas (mga#7766)

* Sat Sep 08 2012 blino <blino> 0.4.7-9.mga3
+ Revision: 290383
- move obsoletes to the library package (main package is not created since it does not have any files)

* Sat Sep 08 2012 blino <blino> 0.4.7-8.mga3
+ Revision: 290347
- obsolete mozjs sub-module when disabled to automatically fix #6299 on upgrades
- fix build with gcc 4.7 (upstream r833)
- force js engine sub-module creation even if only one is enabled
- use apply_patches macro
- disable mozjs build by default, mozjs185 symbols conflict with firefox and make it crash (#6299)

* Wed May 30 2012 jquelin <jquelin> 0.4.7-7.mga3
+ Revision: 250907
- perl 5.16 rebuild

* Tue Apr 17 2012 blino <blino> 0.4.7-6.mga2
+ Revision: 231177
- require NetworkManager detection module in Gnome and KDE packages
  (it only pulls dbus as a dependency)
- add networkmanager subpackage
- add back libproxy-mozjs and libproxy-webkit packages
- mozjs: fix resolving local hostname (from upstream)
- enable networkmanager module
- enable again mozjs support using mozjs185 (patch from upstream)

* Sun Feb 19 2012 tv <tv> 0.4.7-5.mga2
+ Revision: 210753
- fix obsoletes on x86_64

* Sat Feb 18 2012 tv <tv> 0.4.7-4.mga2
+ Revision: 210510
- drop libproxy-webkit
- drop libproxy-mozjs
- do not try to build with libxulrunner
- rebuild for new xulrunner

* Sat Sep 17 2011 fwang <fwang> 0.4.7-3.mga2
+ Revision: 144519
- correct build with webkit 1.5

* Wed Jun 22 2011 cjw <cjw> 0.4.7-2.mga2
+ Revision: 112515
- allow biarch installation of modules
- put the gnome3 config helper app in /usr/lib in a separate package

* Tue Jun 21 2011 cjw <cjw> 0.4.7-1.mga2
+ Revision: 111504
- 0.4.7
- drop gnome2 module
- add gnome3 module
- drop libmodman package: it is now built into libproxy and nothing else used it
- build webkit module against webkitgtk3

* Sat Jun 11 2011 sander85 <sander85> 0.4.6-9.mga2
+ Revision: 103956
- perl 5.14

* Sun May 15 2011 pterjan <pterjan> 0.4.6-8.mga1
+ Revision: 98944
- Rebuild for fixed find-requires

* Wed Apr 20 2011 pterjan <pterjan> 0.4.6-7.mga1
+ Revision: 89143
- Use upstream fix for firefox 4
+ ennael <ennael>
- obsoletes libproxy0 (upgrade from mdv)

* Sat Jan 22 2011 pterjan <pterjan> 0.4.6-5.mga1
+ Revision: 33136
- Fix build with firefox 4
- Disbale bootstrap
+ jquelin <jquelin>
- rebuild

* Sat Jan 15 2011 blino <blino> 0.4.6-3.mga1
+ Revision: 18885
- bootstrap libproxy
- do not build xulrunner and kde plugins in bootstrap
- imported package libproxy


* Wed Nov 03 2010 Götz Waschk <waschk@mandriva.org> 0.4.6-2mdv2011.0
+ Revision: 592881
- rebuild for new python 2.7

* Mon Sep 06 2010 Götz Waschk <waschk@mandriva.org> 0.4.6-1mdv2011.0
+ Revision: 576217
- python module is arch-dependant
- new version
- drop patches
- new libmodman major 1

* Mon Aug 09 2010 Götz Waschk <waschk@mandriva.org> 0.4.4-3mdv2011.0
+ Revision: 568091
- disable bootstrap

* Mon Aug 09 2010 Götz Waschk <waschk@mandriva.org> 0.4.4-2mdv2011.0
+ Revision: 568077
- fix bootstrapping option
- bootstrap build
- fix pkgconfig file

* Mon Aug 09 2010 Götz Waschk <waschk@mandriva.org> 0.4.4-1mdv2011.0
+ Revision: 568003
- new version
- new major
- add libmodman
- drop patches 1,2,3
- fix build
- add perl binding

* Sat Jan 02 2010 Götz Waschk <waschk@mandriva.org> 0.3.1-2mdv2010.1
+ Revision: 485011
- don't apply patch 3 on Cooker, fixes build

* Thu Nov 26 2009 Funda Wang <fwang@mandriva.org> 0.3.1-1mdv2010.1
+ Revision: 470293
- New version 0.3.1
- fix linkage of modules

* Mon Sep 28 2009 Olivier Blin <oblin@mandriva.com> 0.2.3-4mdv2010.0
+ Revision: 450562
- use libxul-unstable headers for jsapi.h, patch from upstream
  http://code.google.com/p/libproxy/issues/detail?id=44
- add bootstrap (from Arnaud Patard)
  fix loop libsoup->libproxy->webkitgtk-devel->libsoup

* Thu Mar 12 2009 Frederik Himpe <fhimpe@mandriva.org> 0.2.3-3mdv2009.1
+ Revision: 354376
- Rebuild for new webkit major

* Tue Feb 03 2009 Götz Waschk <waschk@mandriva.org> 0.2.3-2mdv2009.1
+ Revision: 336801
- remove deps from the library package

* Mon Feb 02 2009 Götz Waschk <waschk@mandriva.org> 0.2.3-1mdv2009.1
+ Revision: 336716
- fix deps
- import libproxy


* Mon Feb  2 2009 Götz Waschk <waschk@mandriva.org> 0.2.3-1mdv2009.1
- initial package based on Fedora

* Thu Jan 22 2009 kwizart < kwizart at gmail.com > - 0.2.3-8
- Merge NetworkManager module into the main libproxy package
- Main Requires the -python and -bin subpackage 
 (splitted for multilibs compliance).

* Fri Oct 24 2008 kwizart < kwizart at gmail.com > - 0.2.3-7
- Disable Gnome/KDE default support via builtin modules.
 (it needs to be integrated via Gconf2/neon instead).

* Tue Oct 21 2008 kwizart < kwizart at gmail.com > - 0.2.3-6
- Disable Obsoletes.
- Requires ev instead of evr for optionnals sub-packages.

* Tue Oct 21 2008 kwizart < kwizart at gmail.com > - 0.2.3-5
- Use conditionals build.

* Mon Sep 15 2008 kwizart < kwizart at gmail.com > - 0.2.3-4
- Remove plugin- in the name of the packages

* Mon Aug  4 2008 kwizart < kwizart at gmail.com > - 0.2.3-3
- Move proxy.h to libproxy/proxy.h
  This will prevent it to be included in the default include path
- Split main to libs and util and use libproxy to install all

* Mon Aug  4 2008 kwizart < kwizart at gmail.com > - 0.2.3-2
- Rename binding-python to python
- Add Requires: gecko-libs >= %%{gecko_version}
- Fix some descriptions
- Add plugin-webkit package
 
* Fri Jul 11 2008 kwizart < kwizart at gmail.com > - 0.2.3-1
- Convert to Fedora spec

* Fri Jun 6 2008 - dominique-rpm@leuenberger.net
- Updated to version 0.2.3
* Wed Jun 4 2008 - dominique-rpm@leuenberger.net
- Extended spec file to build all available plugins
* Tue Jun 3 2008 - dominique-rpm@leuenberger.net
- Initial spec file for Version 0.2.2

